(* generated file, do not edit *)
module System : Netsys_gssapi.GSSAPI = struct
  open Netsys_gssapi
  open Netgss_bindings
  include Netgss_util

  type credential = gss_cred_id_t
  type context = gss_ctx_id_t
  type name = gss_name_t
  type context_option = context option
  type cb_option = channel_bindings option
  type ret_flags = ret_flag list
  type time_opt = float option
  type wrap_size = int
  type req_flags = req_flag list
  type token_option = token option

  exception Credential of credential
  exception Context of context
  exception Name of name

  class type gss_api = [ credential, name, context ] Netsys_gssapi.poly_gss_api

  let interface : gss_api =
    ( object
        method provider = "Netsys_gssapi.System"
        method no_credential = no_credential()
        method no_name = no_name()
        method is_no_credential = is_no_credential
        method is_no_name = is_no_name
        method accept_sec_context :
          't .
            context:context_option ->
            acceptor_cred:gss_cred_id_t ->
            input_token:token ->
            chan_bindings:cb_option ->
            out:(
              src_name:gss_name_t ->
              mech_type:oid ->
              output_context:context_option ->
              output_token:token ->
              ret_flags:flags ->
              time_rec:time ->
              delegated_cred:gss_cred_id_t ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~acceptor_cred ~input_token ~chan_bindings ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status, context, src_name, mech_type, output_token, ret_flags, time_rec, delegated_cred = 
              gss_accept_sec_context
                (_gss_ctx_id_t_of_context_option context)
                (identity acceptor_cred)
                (release_soon _gss_buffer_t_of_token input_token)
                (_gss_channel_bindings_t_of_cb_option chan_bindings) in
            List.iter release_buffer !buffers;
            out
              ~src_name:(identity src_name)
              ~mech_type:(_oid_of_gss_OID mech_type)
              ~output_context:(_context_option_of_gss_ctx_id_t context)
              ~output_token:(_token_of_gss_buffer_t output_token)
              ~ret_flags:(identity ret_flags)
              ~time_rec:(_time_of_OM_uint32 time_rec)
              ~delegated_cred:(identity delegated_cred)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method acquire_cred :
          't .
            desired_name:gss_name_t ->
            time_req:time ->
            desired_mechs:oid_set ->
            cred_usage:gss_cred_usage_t ->
            out:(
              cred:gss_cred_id_t ->
              actual_mechs:oid_set ->
              time_rec:time ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~desired_name ~time_req ~desired_mechs ~cred_usage ~out () ->
            let major_status, minor_status, cred, actual_mechs, time_rec = 
              gss_acquire_cred
                (identity desired_name)
                (_OM_uint32_of_time time_req)
                (_gss_OID_set_of_oid_set desired_mechs)
                (identity cred_usage) in
            out
              ~cred:(identity cred)
              ~actual_mechs:(_oid_set_of_gss_OID_set actual_mechs)
              ~time_rec:(_time_of_OM_uint32 time_rec)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method init_sec_context :
          't .
            initiator_cred:gss_cred_id_t ->
            context:context_option ->
            target_name:gss_name_t ->
            mech_type:oid ->
            req_flags:req_flags ->
            time_req:time_opt ->
            chan_bindings:cb_option ->
            input_token:token_option ->
            out:(
              actual_mech_type:oid ->
              output_context:context_option ->
              output_token:token ->
              ret_flags:flags ->
              time_rec:time ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~initiator_cred ~context ~target_name ~mech_type ~req_flags ~time_req ~chan_bindings ~input_token ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status, context, actual_mech_type, output_token, ret_flags, time_rec = 
              gss_init_sec_context
                (identity initiator_cred)
                (_gss_ctx_id_t_of_context_option context)
                (identity target_name)
                (_gss_OID_of_oid mech_type)
                (_flags_of_req_flags req_flags)
                (_OM_uint32_of_time_opt time_req)
                (_gss_channel_bindings_t_of_cb_option chan_bindings)
                (release_soon _gss_buffer_t_of_token_option input_token) in
            List.iter release_buffer !buffers;
            out
              ~actual_mech_type:(_oid_of_gss_OID actual_mech_type)
              ~output_context:(_context_option_of_gss_ctx_id_t context)
              ~output_token:(_token_of_gss_buffer_t output_token)
              ~ret_flags:(identity ret_flags)
              ~time_rec:(_time_of_OM_uint32 time_rec)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method process_context_token :
          't .
            context:gss_ctx_id_t ->
            token:token ->
            out:(
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~token ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status = 
              gss_process_context_token
                (identity context)
                (release_soon _gss_buffer_t_of_token token) in
            List.iter release_buffer !buffers;
            out
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method context_time :
          't .
            context:gss_ctx_id_t ->
            out:(
              time_rec:time ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~out () ->
            let major_status, minor_status, time_rec = 
              gss_context_time
                (identity context) in
            out
              ~time_rec:(_time_of_OM_uint32 time_rec)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method get_mic :
          't .
            context:gss_ctx_id_t ->
            qop_req:int32 ->
            message:message ->
            out:(
              msg_token:token ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~qop_req ~message ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status, msg_token = 
              gss_get_mic
                (identity context)
                (_OM_uint32_of_int32 qop_req)
                (release_soon _gss_buffer_t_of_message message) in
            List.iter release_buffer !buffers;
            out
              ~msg_token:(_token_of_gss_buffer_t msg_token)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method verify_mic :
          't .
            context:gss_ctx_id_t ->
            message:message ->
            token:token ->
            out:(
              qop_state:int32 ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~message ~token ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status, qop_state = 
              gss_verify_mic
                (identity context)
                (release_soon _gss_buffer_t_of_message message)
                (release_soon _gss_buffer_t_of_token token) in
            List.iter release_buffer !buffers;
            out
              ~qop_state:(_int32_of_OM_uint32 qop_state)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method wrap :
          't .
            context:gss_ctx_id_t ->
            conf_req:bool ->
            qop_req:int32 ->
            input_message:message ->
            output_message_preferred_type:[`Bytes|`Memory] ->
            out:(
              conf_state:bool ->
              output_message:message ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~conf_req ~qop_req ~input_message ~output_message_preferred_type ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status, conf_state, output_message = 
              gss_wrap
                (identity context)
                (identity conf_req)
                (_OM_uint32_of_int32 qop_req)
                (release_soon _gss_buffer_t_of_message input_message) in
            List.iter release_buffer !buffers;
            out
              ~conf_state:(identity conf_state)
              ~output_message:((_message_of_gss_buffer_t output_message_preferred_type) output_message)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method unwrap :
          't .
            context:gss_ctx_id_t ->
            input_message:message ->
            output_message_preferred_type:[`Bytes|`Memory] ->
            out:(
              output_message:message ->
              conf_state:bool ->
              qop_state:int32 ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~input_message ~output_message_preferred_type ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status, output_message, conf_state, qop_state = 
              gss_unwrap
                (identity context)
                (release_soon _gss_buffer_t_of_message input_message) in
            List.iter release_buffer !buffers;
            out
              ~output_message:((_message_of_gss_buffer_t output_message_preferred_type) output_message)
              ~conf_state:(identity conf_state)
              ~qop_state:(_int32_of_OM_uint32 qop_state)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method indicate_mechs :
          't .
            out:(
              mech_set:oid_set ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~out () ->
            let major_status, minor_status, mech_set = 
              gss_indicate_mechs
                () in
            out
              ~mech_set:(_oid_set_of_gss_OID_set mech_set)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method compare_name :
          't .
            name1:gss_name_t ->
            name2:gss_name_t ->
            out:(
              name_equal:bool ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~name1 ~name2 ~out () ->
            let major_status, minor_status, name_equal = 
              gss_compare_name
                (identity name1)
                (identity name2) in
            out
              ~name_equal:(identity name_equal)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method display_name :
          't .
            input_name:gss_name_t ->
            out:(
              output_name:token ->
              output_name_type:oid ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~input_name ~out () ->
            let major_status, minor_status, output_name, output_name_type = 
              gss_display_name
                (identity input_name) in
            out
              ~output_name:(_token_of_gss_buffer_t output_name)
              ~output_name_type:(_oid_of_gss_OID output_name_type)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method import_name :
          't .
            input_name:token ->
            input_name_type:oid ->
            out:(
              output_name:gss_name_t ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~input_name ~input_name_type ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status, output_name = 
              gss_import_name
                (release_soon _gss_buffer_t_of_token input_name)
                (_gss_OID_of_oid input_name_type) in
            List.iter release_buffer !buffers;
            out
              ~output_name:(identity output_name)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method inquire_cred :
          't .
            cred:gss_cred_id_t ->
            out:(
              name:gss_name_t ->
              lifetime:time ->
              cred_usage:gss_cred_usage_t ->
              mechanisms:oid_set ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~cred ~out () ->
            let major_status, minor_status, name, lifetime, cred_usage, mechanisms = 
              gss_inquire_cred
                (identity cred) in
            out
              ~name:(identity name)
              ~lifetime:(_time_of_OM_uint32 lifetime)
              ~cred_usage:(identity cred_usage)
              ~mechanisms:(_oid_set_of_gss_OID_set mechanisms)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method inquire_context :
          't .
            context:gss_ctx_id_t ->
            out:(
              src_name:gss_name_t ->
              targ_name:gss_name_t ->
              lifetime_req:time ->
              mech_type:oid ->
              ctx_flags:flags ->
              locally_initiated:bool ->
              is_open:bool ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~out () ->
            let major_status, minor_status, src_name, targ_name, lifetime_req, mech_type, ctx_flags, locally_initiated, is_open = 
              gss_inquire_context
                (identity context) in
            out
              ~src_name:(identity src_name)
              ~targ_name:(identity targ_name)
              ~lifetime_req:(_time_of_OM_uint32 lifetime_req)
              ~mech_type:(_oid_of_gss_OID mech_type)
              ~ctx_flags:(identity ctx_flags)
              ~locally_initiated:(identity locally_initiated)
              ~is_open:(identity is_open)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method wrap_size_limit :
          't .
            context:gss_ctx_id_t ->
            conf_req:bool ->
            qop_req:int32 ->
            req_output_size:wrap_size ->
            out:(
              max_input_size:wrap_size ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~conf_req ~qop_req ~req_output_size ~out () ->
            let major_status, minor_status, max_input_size = 
              gss_wrap_size_limit
                (identity context)
                (identity conf_req)
                (_OM_uint32_of_int32 qop_req)
                (_OM_uint32_of_wrap_size req_output_size) in
            out
              ~max_input_size:(_wrap_size_of_OM_uint32 max_input_size)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method add_cred :
          't .
            input_cred:gss_cred_id_t ->
            desired_name:gss_name_t ->
            desired_mech:oid ->
            cred_usage:gss_cred_usage_t ->
            initiator_time_req:time ->
            acceptor_time_req:time ->
            out:(
              output_cred:gss_cred_id_t ->
              actual_mechs:oid_set ->
              initiator_time_rec:time ->
              acceptor_time_rec:time ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~input_cred ~desired_name ~desired_mech ~cred_usage ~initiator_time_req ~acceptor_time_req ~out () ->
            let major_status, minor_status, output_cred, actual_mechs, initiator_time_rec, acceptor_time_rec = 
              gss_add_cred
                (identity input_cred)
                (identity desired_name)
                (_gss_OID_of_oid desired_mech)
                (identity cred_usage)
                (_OM_uint32_of_time initiator_time_req)
                (_OM_uint32_of_time acceptor_time_req) in
            out
              ~output_cred:(identity output_cred)
              ~actual_mechs:(_oid_set_of_gss_OID_set actual_mechs)
              ~initiator_time_rec:(_time_of_OM_uint32 initiator_time_rec)
              ~acceptor_time_rec:(_time_of_OM_uint32 acceptor_time_rec)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method inquire_cred_by_mech :
          't .
            cred:gss_cred_id_t ->
            mech_type:oid ->
            out:(
              name:gss_name_t ->
              initiator_lifetime:time ->
              acceptor_lifetime:time ->
              cred_usage:gss_cred_usage_t ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~cred ~mech_type ~out () ->
            let major_status, minor_status, name, initiator_lifetime, acceptor_lifetime, cred_usage = 
              gss_inquire_cred_by_mech
                (identity cred)
                (_gss_OID_of_oid mech_type) in
            out
              ~name:(identity name)
              ~initiator_lifetime:(_time_of_OM_uint32 initiator_lifetime)
              ~acceptor_lifetime:(_time_of_OM_uint32 acceptor_lifetime)
              ~cred_usage:(identity cred_usage)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method export_sec_context :
          't .
            context:gss_ctx_id_t ->
            out:(
              interprocess_token:token ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~out () ->
            let major_status, minor_status, interprocess_token = 
              gss_export_sec_context
                (identity context) in
            out
              ~interprocess_token:(_token_of_gss_buffer_t interprocess_token)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method import_sec_context :
          't .
            interprocess_token:token ->
            out:(
              context:context_option ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~interprocess_token ~out () ->
            let buffers = ref [] in
            let release_soon f arg = let buf = f arg in buffers := buf :: !buffers; buf in
            let major_status, minor_status, context = 
              gss_import_sec_context
                (release_soon _gss_buffer_t_of_token interprocess_token) in
            List.iter release_buffer !buffers;
            out
              ~context:(_context_option_of_gss_ctx_id_t context)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method inquire_names_for_mech :
          't .
            mechanism:oid ->
            out:(
              name_types:oid_set ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~mechanism ~out () ->
            let major_status, minor_status, name_types = 
              gss_inquire_names_for_mech
                (_gss_OID_of_oid mechanism) in
            out
              ~name_types:(_oid_set_of_gss_OID_set name_types)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method inquire_mechs_for_name :
          't .
            name:gss_name_t ->
            out:(
              mech_types:oid_set ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~name ~out () ->
            let major_status, minor_status, mech_types = 
              gss_inquire_mechs_for_name
                (identity name) in
            out
              ~mech_types:(_oid_set_of_gss_OID_set mech_types)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method export_name :
          't .
            name:gss_name_t ->
            out:(
              exported_name:token ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~name ~out () ->
            let major_status, minor_status, exported_name = 
              gss_export_name
                (identity name) in
            out
              ~exported_name:(_token_of_gss_buffer_t exported_name)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method duplicate_name :
          't .
            name:gss_name_t ->
            out:(
              dest_name:gss_name_t ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~name ~out () ->
            let major_status, minor_status, dest_name = 
              gss_duplicate_name
                (identity name) in
            out
              ~dest_name:(identity dest_name)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method canonicalize_name :
          't .
            input_name:gss_name_t ->
            mech_type:oid ->
            out:(
              output_name:gss_name_t ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~input_name ~mech_type ~out () ->
            let major_status, minor_status, output_name = 
              gss_canonicalize_name
                (identity input_name)
                (_gss_OID_of_oid mech_type) in
            out
              ~output_name:(identity output_name)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method delete_sec_context :
          't .
            context:gss_ctx_id_t ->
            out:(
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~context ~out () ->
            let major_status, minor_status = 
              gss_delete_sec_context
                (identity context) in
            out
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
        method display_minor_status :
          't .
            status_value:int32 ->
            mech_type:oid ->
            out:(
              status_strings:string list ->
              minor_status:minor_status ->
              major_status:major_status ->
              unit ->
              't
            ) -> unit -> 't =
          fun ~status_value ~mech_type ~out () ->
            let major_status, minor_status, status_strings = 
              gss_display_minor_status
                (identity status_value)
                (_gss_OID_of_oid mech_type) in
            out
              ~status_strings:(identity status_strings)
              ~minor_status
              ~major_status:(decode_status major_status)
              ()
      end
    )
end
