type gss_buffer_t
type gss_OID
type gss_OID_set
type gss_cred_id_t
type gss_ctx_id_t
type gss_name_t
type gss_channel_bindings_t
type gss_cred_usage_t =
  [ `Both
  | `Initiate
  | `Accept
  ]
type flags_flag =
  [ `Deleg_flag
  | `Mutual_flag
  | `Replay_flag
  | `Sequence_flag
  | `Conf_flag
  | `Integ_flag
  | `Anon_flag
  | `Prot_ready_flag
  | `Trans_flag
  ]
type flags = flags_flag list
type gss_qop_t =
  [ `Qop_default
  ]
type status_type_t =
  [ `Gss_code
  | `Mech_code
  ]
external gss_accept_sec_context : gss_ctx_id_t -> gss_cred_id_t -> gss_buffer_t -> gss_channel_bindings_t -> int32 * int32 * gss_ctx_id_t * gss_name_t * gss_OID * gss_buffer_t * flags * int32 * gss_cred_id_t
 = "net_gss_accept_sec_context" "net_gss_accept_sec_context"
external gss_acquire_cred : gss_name_t -> int32 -> gss_OID_set -> gss_cred_usage_t -> int32 * int32 * gss_cred_id_t * gss_OID_set * int32
 = "net_gss_acquire_cred" "net_gss_acquire_cred"
external gss_init_sec_context : gss_cred_id_t -> gss_ctx_id_t -> gss_name_t -> gss_OID -> flags -> int32 -> gss_channel_bindings_t -> gss_buffer_t -> int32 * int32 * gss_ctx_id_t * gss_OID * gss_buffer_t * flags * int32
 = "net_gss_init_sec_context__byte" "net_gss_init_sec_context"
external gss_process_context_token : gss_ctx_id_t -> gss_buffer_t -> int32 * int32
 = "net_gss_process_context_token" "net_gss_process_context_token"
external gss_context_time : gss_ctx_id_t -> int32 * int32 * int32
 = "net_gss_context_time" "net_gss_context_time"
external gss_get_mic : gss_ctx_id_t -> int32 -> gss_buffer_t -> int32 * int32 * gss_buffer_t
 = "net_gss_get_mic" "net_gss_get_mic"
external gss_verify_mic : gss_ctx_id_t -> gss_buffer_t -> gss_buffer_t -> int32 * int32 * int32
 = "net_gss_verify_mic" "net_gss_verify_mic"
external gss_wrap : gss_ctx_id_t -> bool -> int32 -> gss_buffer_t -> int32 * int32 * bool * gss_buffer_t
 = "net_gss_wrap" "net_gss_wrap"
external gss_unwrap : gss_ctx_id_t -> gss_buffer_t -> int32 * int32 * gss_buffer_t * bool * int32
 = "net_gss_unwrap" "net_gss_unwrap"
external gss_display_status : int32 -> status_type_t -> gss_OID -> int32 -> int32 * int32 * int32 * gss_buffer_t
 = "net_gss_display_status" "net_gss_display_status"
external gss_indicate_mechs : unit -> int32 * int32 * gss_OID_set
 = "net_gss_indicate_mechs" "net_gss_indicate_mechs"
external gss_compare_name : gss_name_t -> gss_name_t -> int32 * int32 * bool
 = "net_gss_compare_name" "net_gss_compare_name"
external gss_display_name : gss_name_t -> int32 * int32 * gss_buffer_t * gss_OID
 = "net_gss_display_name" "net_gss_display_name"
external gss_import_name : gss_buffer_t -> gss_OID -> int32 * int32 * gss_name_t
 = "net_gss_import_name" "net_gss_import_name"
external gss_inquire_cred : gss_cred_id_t -> int32 * int32 * gss_name_t * int32 * gss_cred_usage_t * gss_OID_set
 = "net_gss_inquire_cred" "net_gss_inquire_cred"
external gss_inquire_context : gss_ctx_id_t -> int32 * int32 * gss_name_t * gss_name_t * int32 * gss_OID * flags * bool * bool
 = "net_gss_inquire_context" "net_gss_inquire_context"
external gss_wrap_size_limit : gss_ctx_id_t -> bool -> int32 -> int32 -> int32 * int32 * int32
 = "net_gss_wrap_size_limit" "net_gss_wrap_size_limit"
external gss_add_cred : gss_cred_id_t -> gss_name_t -> gss_OID -> gss_cred_usage_t -> int32 -> int32 -> int32 * int32 * gss_cred_id_t * gss_OID_set * int32 * int32
 = "net_gss_add_cred__byte" "net_gss_add_cred"
external gss_inquire_cred_by_mech : gss_cred_id_t -> gss_OID -> int32 * int32 * gss_name_t * int32 * int32 * gss_cred_usage_t
 = "net_gss_inquire_cred_by_mech" "net_gss_inquire_cred_by_mech"
external gss_export_sec_context : gss_ctx_id_t -> int32 * int32 * gss_buffer_t
 = "net_gss_export_sec_context" "net_gss_export_sec_context"
external gss_import_sec_context : gss_buffer_t -> int32 * int32 * gss_ctx_id_t
 = "net_gss_import_sec_context" "net_gss_import_sec_context"
external gss_inquire_names_for_mech : gss_OID -> int32 * int32 * gss_OID_set
 = "net_gss_inquire_names_for_mech" "net_gss_inquire_names_for_mech"
external gss_inquire_mechs_for_name : gss_name_t -> int32 * int32 * gss_OID_set
 = "net_gss_inquire_mechs_for_name" "net_gss_inquire_mechs_for_name"
external gss_export_name : gss_name_t -> int32 * int32 * gss_buffer_t
 = "net_gss_export_name" "net_gss_export_name"
external gss_duplicate_name : gss_name_t -> int32 * int32 * gss_name_t
 = "net_gss_duplicate_name" "net_gss_duplicate_name"
external gss_canonicalize_name : gss_name_t -> gss_OID -> int32 * int32 * gss_name_t
 = "net_gss_canonicalize_name" "net_gss_canonicalize_name"
external gss_delete_sec_context : gss_ctx_id_t -> int32 * int32
 = "net_gss_delete_sec_context" "net_gss_delete_sec_context"
(* This file is included into netgss_bindings.ml *)

exception Null_pointer

type memory = 
    (char,Bigarray.int8_unsigned_elt,Bigarray.c_layout) Bigarray.Array1.t

external buffer_of_string : string -> int -> int -> gss_buffer_t
  = "netgss_buffer_of_string"

external buffer_of_bytes : Bytes.t -> int -> int -> gss_buffer_t
  = "netgss_buffer_of_string"

external buffer_of_memory : memory -> gss_buffer_t
  = "netgss_buffer_of_memory"

external string_of_buffer : gss_buffer_t -> string
  = "netgss_string_of_buffer"

external bytes_of_buffer : gss_buffer_t -> Bytes.t
  = "netgss_string_of_buffer"

external netgss_memory_of_buffer : gss_buffer_t -> memory
  = "netgss_memory_of_buffer"

let hide_reference x _ =
  x := None

let memory_of_buffer buf =
  let buf_opt = ref (Some buf) in
  let finalizer = hide_reference buf_opt in
  let m = 
    try netgss_memory_of_buffer buf
    with Null_pointer ->
      Bigarray.Array1.create Bigarray.char Bigarray.c_layout 0 in
  Gc.finalise finalizer m;
  m

external release_buffer : gss_buffer_t -> unit
  = "netgss_release_buffer"

external oid_of_der : string -> gss_OID
  = "netgss_oid_of_string"

external der_of_oid : gss_OID -> string
  = "netgss_string_of_oid"

external array_of_oid_set : gss_OID_set -> gss_OID array
  = "netgss_array_of_oid_set"

external oid_set_of_array : gss_OID array -> gss_OID_set
  = "netgss_oid_set_of_array"

external map_cb : int -> string -> int -> string -> string -> 
                  gss_channel_bindings_t
  = "netgss_map_cb"

external no_channel_bindings : unit -> gss_channel_bindings_t
  = "netgss_no_cb"

external no_context : unit -> gss_ctx_id_t
  = "netgss_no_ctx"

external is_no_context : gss_ctx_id_t -> bool
  = "netgss_is_no_ctx"

external no_credential : unit -> gss_cred_id_t
  = "netgss_no_cred"

external is_no_credential : gss_cred_id_t -> bool
  = "netgss_is_no_cred"

external no_name : unit -> gss_name_t
  = "netgss_no_name"

external is_no_name : gss_name_t -> bool
  = "netgss_is_no_name"

external gss_indefinite : unit -> int32
  = "netgss_indefinite"

external no_oid : unit -> gss_OID
  = "netgss_no_oid"

external no_oid_set : unit -> gss_OID_set
  = "netgss_no_oid_set"

let () =
  Callback.register_exception
    "Netgss_bindings.Null_pointer"
    Null_pointer
